import { Vector } from "../../src/Vector";
export declare function requireNotNull<T>(x: T | null): T;
export declare function indent(count: number): string;
export declare type LineByIndent = {
    contents: string;
    indent: number;
};
export declare type LinesByIndent = Vector<LineByIndent>;
export declare function fileGetLinesByIndent(fname: string): LinesByIndent;
/**
 * extract a tag from the linesbyindent. You tell me the tag name,
 * how to match the start tag, I return to you the rows before, the rows within that
 * tag (depth>=tagDepth) and the rows after.
 * returns [before, atTag, after]
 */
export declare function linesByIndentGetTagContents(lines: LinesByIndent, tagName: string, startPredicate: (line: string) => boolean): [LinesByIndent, LinesByIndent, LinesByIndent];
export declare function linesByIndentStr(linesByIndent: LinesByIndent): string;
