"use strict";
exports.__esModule = true;
var fs_1 = require("fs");
function makeModule(moduleName, filename) {
    var contents = fs_1.readFileSync(filename).toString();
    var moduleStart = "export module " + moduleName + " { ";
    var contentsWithModuleHeader = contents.trim().startsWith("/**") ?
        // add the module header at the end of the apidoc comment
        // so the comment apidoc covers the module
        contents.replace(/\*\//, "*/ " + moduleStart) :
        // add the module header straight at the top of the file
        moduleStart + contents;
    // in any case close at the end of the file
    fs_1.writeFileSync(filename, contentsWithModuleHeader + "\n}\n");
}
// list of files for which to trick typedoc
// to think they're external modules
makeModule("Comparison", "src/Comparison.ts");
makeModule("Contract", "src/Contract.ts");
makeModule("Option", "src/Option.ts");
makeModule("Either", "src/Either.ts");
makeModule("LinkedList", "src/LinkedList.ts");
makeModule("Stream", "src/Stream.ts");
makeModule("Function", "src/Function.ts");
makeModule("Predicate", "src/Predicate.ts");
//# sourceMappingURL=make_doc_preprocess.js.map