"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var Future_1 = require("../src/Future");
var Option_1 = require("../src/Option");
var Either_1 = require("../src/Either");
var assert = require("assert");
function ensureFailedWithValue(val, promise) {
    return __awaiter(this, void 0, void 0, function () {
        var v, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, promise];
                case 1:
                    v = _a.sent();
                    assert.ok(false);
                    return [3 /*break*/, 3];
                case 2:
                    err_1 = _a.sent();
                    assert.deepEqual(val, err_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/];
            }
        });
    });
}
describe("Future.of", function () {
    it("properly wraps successful promises with of", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [5];
                    return [4 /*yield*/, Future_1.Future.of(new Promise(function (a, r) { return a(5); }))];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("properly wraps failed promises with of", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            // shows the need for future.catch!?
            // await Future.of(new Promise((a,r) => r(5)))
            return [2 /*return*/, ensureFailedWithValue(5, Future_1.Future.of(Promise.reject(5)).toPromise())];
        });
    }); });
});
describe("Future basics", function () {
    it("is lazy", function () {
        var i = 0;
        Future_1.Future.ofCallbackApi(function (done) { ++i; done(i); });
        assert.deepEqual(0, i);
    });
    it("works when triggered", function () { return __awaiter(_this, void 0, void 0, function () {
        var i;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    return [4 /*yield*/, Future_1.Future.ofCallbackApi(function (done) { return done(++i); })];
                case 1:
                    _a.sent();
                    assert.deepEqual(1, i);
                    return [2 /*return*/];
            }
        });
    }); });
    it("handles errors", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, msg;
        return __generator(this, function (_a) {
            i = 0;
            msg = null;
            Future_1.Future.ofCallbackApi(function (done) { throw "oops"; })
                .map(function (x) { return ++i; })
                .onFailure(function (err) { return msg = err; })
                .toPromise().then(function (success) { return assert.ok(false); }, function (failed) {
                assert.deepEqual("oops", failed);
                assert.deepEqual(0, i);
                assert.deepEqual("oops", msg);
            });
            return [2 /*return*/];
        });
    }); });
    it("handles a throw in map", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            // i'm not crazy about this behaviour (not really functor-law like)
            // but it's JS we're dealing with in the end :-(
            return [2 /*return*/, ensureFailedWithValue("oops", Future_1.Future.ok(5).map(function (x) { throw "oops"; }).toPromise())];
        });
    }); });
    it("handles a throw in flatMap", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            // i'm not crazy about this behaviour (not really functor-law like)
            // but it's JS we're dealing with in the end :-(
            return [2 /*return*/, ensureFailedWithValue("oops", Future_1.Future.ok(5).flatMap(function (x) { throw "oops"; }).toPromise())];
        });
    }); });
    it("called only once if triggered twice", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, f;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    f = Future_1.Future.ofCallbackApi(function (done) { ++i; done(1); });
                    return [4 /*yield*/, f];
                case 1:
                    _a.sent();
                    assert.deepEqual(1, i);
                    return [4 /*yield*/, f];
                case 2:
                    _a.sent();
                    assert.deepEqual(1, i);
                    return [2 /*return*/];
            }
        });
    }); });
    it("is async also when triggered", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, f, _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    i = 0;
                    f = Future_1.Future.ofCallbackApi(function (done) { return setTimeout(done, 20, ++i); });
                    assert.deepEqual(0, i);
                    _b = (_a = assert).deepEqual;
                    _c = [1];
                    return [4 /*yield*/, f];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    assert.deepEqual(1, i);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe("Future.map*", function () {
    it("map triggers and works", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, f, _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    i = 0;
                    f = Future_1.Future.ofCallbackApi(function (done) { return done(++i); }).map(function (x) { return x * 2; });
                    assert.deepEqual(1, i);
                    _b = (_a = assert).deepEqual;
                    _c = [2];
                    return [4 /*yield*/, f];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("map doesn't flatten promises", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, f, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    i = 0;
                    f = Future_1.Future.ofCallbackApi(function (done) { return done(5); })
                        .map(function (x) { return new Promise(function (r, f) { return r(x + 1); }); });
                    _b = (_a = assert).ok;
                    return [4 /*yield*/, f];
                case 1:
                    _b.apply(_a, [(_c.sent()).then !== null]); // should get a promise out
                    return [2 /*return*/];
            }
        });
    }); });
    it("map doesn't flatten futures", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, f, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    i = 0;
                    f = Future_1.Future.ok(5).map(function (x) { return Future_1.Future.ofCallbackApi(function (done) { return done(x + 1); }); });
                    _b = (_a = assert).ok;
                    return [4 /*yield*/, f];
                case 1:
                    _b.apply(_a, [(_c.sent()).getPromise !== null]); // should get a future out
                    return [2 /*return*/];
            }
        });
    }); });
    it("mapFailure works", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, ensureFailedWithValue("SORRY", Future_1.Future.failed("sorry").mapFailure(function (err) { return err.toUpperCase(); }).toPromise())];
        });
    }); });
    it("mapFailure is a nop on successful futures", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [5];
                    return [4 /*yield*/, Future_1.Future.ok(5).mapFailure(function (_) { return "oops"; })];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("flatMap does flatten futures", function () { return __awaiter(_this, void 0, void 0, function () {
        var f, _a, _b, _c, _d, _e;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    f = Future_1.Future.ok(5).flatMap(function (x) { return Future_1.Future.ofCallbackApi(function (done) { return done(x + 1); }); });
                    _b = (_a = assert).ok;
                    return [4 /*yield*/, f];
                case 1:
                    _b.apply(_a, [(_f.sent()).getPromise === undefined]); // shouldn't get a future out
                    _d = (_c = assert).deepEqual;
                    _e = [6];
                    return [4 /*yield*/, f];
                case 2:
                    _d.apply(_c, _e.concat([_f.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
});
describe("Future.liftA*", function () {
    it("applies liftAp properly", function () { return __awaiter(_this, void 0, void 0, function () {
        var fn, computationPromise, _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    fn = function (x) { return ({ a: x.a + 1, b: x.b - 2 }); };
                    computationPromise = Future_1.Future.liftAp(fn)({ a: Future_1.Future.ok(5), b: Future_1.Future.ofCallbackApi(function (done) { return done(12); }) });
                    _b = (_a = assert).deepEqual;
                    _c = [{ a: 6, b: 10 }];
                    return [4 /*yield*/, computationPromise];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("applies liftAp properly in case of failure", function () { return __awaiter(_this, void 0, void 0, function () {
        var fn, computationPromise;
        return __generator(this, function (_a) {
            fn = function (x) { return ({ a: x.a + 1, b: x.b - 2 }); };
            computationPromise = Future_1.Future.liftAp(fn)({ a: Future_1.Future.ok(5), b: Future_1.Future.failed("sorry") });
            return [2 /*return*/, ensureFailedWithValue("sorry", computationPromise.toPromise())];
        });
    }); });
    it("applies liftA2 properly", function () { return __awaiter(_this, void 0, void 0, function () {
        var fn, computationPromise, _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    fn = function (a, b) { return ({ a: a + 1, b: b - 2 }); };
                    computationPromise = Future_1.Future.liftA2(fn)(Future_1.Future.ok(5), Future_1.Future.ofCallbackApi(function (done) { return done(12); }));
                    _b = (_a = assert).deepEqual;
                    _c = [{ a: 6, b: 10 }];
                    return [4 /*yield*/, computationPromise];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("applies liftA2 properly in case of failure", function () { return __awaiter(_this, void 0, void 0, function () {
        var fn, computationPromise;
        return __generator(this, function (_a) {
            fn = function (a, b) { return ({ a: a + 1, b: b - 2 }); };
            computationPromise = Future_1.Future.liftA2(fn)(Future_1.Future.ok(5), Future_1.Future.failed("sorry"));
            return [2 /*return*/, ensureFailedWithValue("sorry", computationPromise.toPromise())];
        });
    }); });
});
describe("Future.traverse", function () {
    it("traverses properly", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [[1, 2, 3]];
                    return [4 /*yield*/, Future_1.Future.traverse([1, 2, 3], Future_1.Future.ok).map(function (v) { return v.toArray(); })];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("traverses properly in case of failure", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, ensureFailedWithValue("3", Future_1.Future.traverse([1, 2, 3], function (x) { return Future_1.Future.ofCallbackApi(function () { if (x < 3) {
                    x;
                }
                else {
                    throw x;
                } }); })
                    .map(function (v) { return v.toArray(); }).toPromise())];
        });
    }); });
});
describe("Future.sequence", function () {
    it("sequences properly", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [[1, 2, 3]];
                    return [4 /*yield*/, Future_1.Future.sequence([Future_1.Future.ok(1), Future_1.Future.ok(2), Future_1.Future.ok(3)]).map(function (v) { return v.toArray(); })];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("sequences properly in case of failure", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, ensureFailedWithValue("3", Future_1.Future.sequence([Future_1.Future.ok(1), Future_1.Future.ok(2), Future_1.Future.failed("3")])
                    .map(function (v) { return v.toArray(); }).toPromise())];
        });
    }); });
});
describe("Future.firstCompletedOf", function () {
    // TODO in these tests check the elapsed time is short!
    it("returns the one finishing the first", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [1];
                    return [4 /*yield*/, Future_1.Future.firstCompletedOf([Future_1.Future.ofCallbackApi(function (done) { return setTimeout(done, 100, 3); }), Future_1.Future.ok(1)])];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("returns the one finishing even if it's a failure", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, ensureFailedWithValue("3", Future_1.Future.firstCompletedOf([Future_1.Future.ofCallbackApi(function (done) { return setTimeout(done, 100, 1); }), Future_1.Future.failed("3")]).toPromise())];
        });
    }); });
});
describe("Future.firstSuccessfulOf", function () {
    // TODO in these tests check the elapsed time is short!
    it("returns the one finishing the first", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [1];
                    return [4 /*yield*/, Future_1.Future.firstSuccessfulOf([Future_1.Future.ofCallbackApi(function (done) { return setTimeout(done, 100, 3); }), Future_1.Future.ok(1)])];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("returns the one finishing slower if the other one is a failure", function () { return __awaiter(_this, void 0, void 0, function () {
        var v;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Future_1.Future.firstSuccessfulOf([Future_1.Future.ofCallbackApi(function (done) { return setTimeout(done, 20, 1); }), Future_1.Future.failed("3")]).toPromise()];
                case 1:
                    v = _a.sent();
                    assert.equal(1, v);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe("Future.filter", function () {
    it("is a nop if no filter to do", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [5];
                    return [4 /*yield*/, Future_1.Future.ok(5).filter(function (x) { return x >= 2; }, function (v) { return "value was " + v; })];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("is a nop if the future was failed", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, ensureFailedWithValue("already bad", Future_1.Future.failed("already bad").filter(function (x) { return x >= 2; }, function (v) { return "value was " + v; }).toPromise())];
        });
    }); });
    it("does filter if it applies", function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, ensureFailedWithValue("value was 1", Future_1.Future.ok(1).filter(function (x) { return x >= 2; }, function (v) { return "value was " + v; }).toPromise())];
        });
    }); });
});
describe("Future.orElse", function () {
    it("is lazy", function () {
        var called = false;
        Future_1.Future.ofCallbackApi(function (done) { called = true; done(2); })
            .orElse(Future_1.Future.ofCallbackApi(function (done) { called = true; done(3); }));
        assert.deepEqual(false, called);
    });
    it("is a nop if the first promise succeeds, even if it's slower", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [1];
                    return [4 /*yield*/, Future_1.Future.ofCallbackApi(function (done) { return setTimeout(done, 50, 1); })
                            .orElse(Future_1.Future.ok(2))];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
    it("falls back to the second promise in case the first one fails", function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _b = (_a = assert).deepEqual;
                    _c = [2];
                    return [4 /*yield*/, Future_1.Future.failed("oops").orElse(Future_1.Future.ok(2))];
                case 1:
                    _b.apply(_a, _c.concat([_d.sent()]));
                    return [2 /*return*/];
            }
        });
    }); });
});
describe("Future.find", function () {
    it("returns the first future if it matches", function () { return __awaiter(_this, void 0, void 0, function () {
        var actual;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Future_1.Future.find([Future_1.Future.ok(2)], function (x) { return x >= 0; })];
                case 1:
                    actual = _a.sent();
                    assert.ok(Option_1.Option.of(2).equals(actual));
                    return [2 /*return*/];
            }
        });
    }); });
    it("returns nothing if no future matches", function () { return __awaiter(_this, void 0, void 0, function () {
        var actual;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Future_1.Future.find([Future_1.Future.ok(-1)], function (x) { return x >= 0; })];
                case 1:
                    actual = _a.sent();
                    assert.ok(Option_1.Option.none().equals(actual));
                    return [2 /*return*/];
            }
        });
    }); });
    it("returns nothing if all futures fail", function () { return __awaiter(_this, void 0, void 0, function () {
        var actual;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Future_1.Future.find([Future_1.Future.failed(-1)], function (x) { return x >= 0; })];
                case 1:
                    actual = _a.sent();
                    assert.ok(Option_1.Option.none().equals(actual));
                    return [2 /*return*/];
            }
        });
    }); });
    it("returns the first matching", function () { return __awaiter(_this, void 0, void 0, function () {
        var actual;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Future_1.Future.find([
                        Future_1.Future.ok(-1),
                        Future_1.Future.failed(5),
                        Future_1.Future.ok(-3),
                        Future_1.Future.ok(6),
                        Future_1.Future.ok(7)
                    ], function (x) { return x >= 0; })];
                case 1:
                    actual = _a.sent();
                    assert.ok(Option_1.Option.of(6).equals(actual));
                    return [2 /*return*/];
            }
        });
    }); });
    it("doesn't wait if there's a success", function () { return __awaiter(_this, void 0, void 0, function () {
        var waited, actual;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    waited = false;
                    return [4 /*yield*/, Future_1.Future.find([
                            Future_1.Future.ok(-1),
                            Future_1.Future.failed(5),
                            Future_1.Future.ok(-3),
                            Future_1.Future.ofCallbackApi(function (done) { return setTimeout(function () { waited = true; done(6); }, 60); }),
                            Future_1.Future.ok(7)
                        ], function (x) { return x >= 0; })];
                case 1:
                    actual = _a.sent();
                    assert.ok(Option_1.Option.of(7).equals(actual));
                    assert.ok(!waited);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe("Future.on*", function () {
    it("calls onSuccess when it should", function () { return __awaiter(_this, void 0, void 0, function () {
        var v;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    v = 0;
                    return [4 /*yield*/, Future_1.Future.ok(5)
                            .onSuccess(function (x) { return v = x; })];
                case 1:
                    _a.sent();
                    assert.deepEqual(5, v);
                    return [2 /*return*/];
            }
        });
    }); });
    it("doesn't calls onSuccess when it shouldn't", function () { return __awaiter(_this, void 0, void 0, function () {
        var v, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    v = 0;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, Future_1.Future.failed(5)
                            .onSuccess(function (x) { return v = x; })];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    _a = _b.sent();
                    return [3 /*break*/, 4];
                case 4:
                    assert.deepEqual(0, v);
                    return [2 /*return*/];
            }
        });
    }); });
    it("doesn't call onFailure when it shouldn't", function () { return __awaiter(_this, void 0, void 0, function () {
        var v;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    v = 0;
                    return [4 /*yield*/, Future_1.Future.ok(5)
                            .onFailure(function (x) { return v = x; })];
                case 1:
                    _a.sent();
                    assert.deepEqual(0, v);
                    return [2 /*return*/];
            }
        });
    }); });
    it("calls onFailure when it should", function () { return __awaiter(_this, void 0, void 0, function () {
        var v, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    v = 0;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, Future_1.Future.failed(5)
                            .onFailure(function (x) { return v = x; })];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    _a = _b.sent();
                    return [3 /*break*/, 4];
                case 4:
                    assert.deepEqual(5, v);
                    return [2 /*return*/];
            }
        });
    }); });
    it("calls onComplete on success", function () { return __awaiter(_this, void 0, void 0, function () {
        var v;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    v = undefined;
                    return [4 /*yield*/, Future_1.Future.ok(5)
                            .onComplete(function (x) { return v = x; })];
                case 1:
                    _a.sent();
                    assert.ok(Either_1.Either.right(5).equals(v));
                    return [2 /*return*/];
            }
        });
    }); });
    it("calls onComplete on failure", function () { return __awaiter(_this, void 0, void 0, function () {
        var v, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    v = undefined;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, Future_1.Future.failed(5)
                            .onComplete(function (x) { return v = x; })];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 3:
                    _a = _b.sent();
                    return [3 /*break*/, 4];
                case 4:
                    assert.ok(Either_1.Either.left(5).equals(v));
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=Future.js.map