"use strict";
exports.__esModule = true;
var LinkedList_1 = require("../src/LinkedList");
var SampleData_1 = require("./SampleData");
var SeqTest = require("./Seq");
var assert = require("assert");
SeqTest.runTests("LinkedList", LinkedList_1.LinkedList.ofIterable, LinkedList_1.LinkedList.of, LinkedList_1.LinkedList.empty, LinkedList_1.LinkedList.unfoldRight, "ConsLinkedList");
describe("LinkedList toString", function () {
    it("serializes to string correctly", function () { return assert.equal("LinkedList(1, 2, 3)", LinkedList_1.LinkedList.of(1, 2, 3).toString()); });
    it("serializes to string correctly - arrays & strings", function () { return assert.equal("LinkedList([1,'a'])", LinkedList_1.LinkedList.of([1, 'a']).toString()); });
    it("serializes to string correctly - custom toString", function () { return assert.equal("LinkedList({field1: hi, field2: 99})", LinkedList_1.LinkedList.of(new SampleData_1.MyClass("hi", 99)).toString()); });
    it("serializes to string correctly - plain map", function () { return assert.equal("LinkedList({\"name\":\"hi\",\"age\":99})", LinkedList_1.LinkedList.of({ name: "hi", age: 99 }).toString()); });
    it("takes advantage of isEmpty", function () {
        var list = LinkedList_1.LinkedList.of(1, 2, 3);
        if (!list.isEmpty()) {
            list.head().get();
        }
    });
});
//# sourceMappingURL=LinkedList.js.map