"use strict";
exports.__esModule = true;
var Predicate_1 = require("../src/Predicate");
var assert = require("assert");
describe("predicate composition", function () {
    it("predicate and composition", function () {
        return assert.ok(Predicate_1.Predicate.of(function (x) { return x > 2; }).and(function (x) { return x < 10; })(5));
    });
    it("predicate and composition 2", function () {
        return assert.ok(!Predicate_1.Predicate.of(function (x) { return x > 2; }).and(function (x) { return x < 10; })(11));
    });
    it("predicate or composition", function () {
        return assert.ok(!Predicate_1.Predicate.of(function (x) { return x < 2; }).or(function (x) { return x > 10; })(5));
    });
    it("predicate or composition 2", function () {
        return assert.ok(Predicate_1.Predicate.of(function (x) { return x < 2; }).or(function (x) { return x > 10; })(11));
    });
    it("predicate negation", function () {
        return assert.ok(Predicate_1.Predicate.of(function (x) { return x < 10; }).negate()(20));
    });
    it("predicate allOf", function () {
        return assert.ok(Predicate_1.Predicate.allOf(function (x) { return x > 10; }, function (x) { return x < 20; }, function (x) { return x % 2 === 0; })(14));
    });
    it("predicate allOf negative", function () {
        return assert.ok(!Predicate_1.Predicate.allOf(function (x) { return x > 10; }, function (x) { return x < 20; }, function (x) { return x % 2 === 0; })(15));
    });
    it("predicate anyOf", function () {
        return assert.ok(Predicate_1.Predicate.anyOf(function (x) { return x < 10; }, function (x) { return x > 20; })(4));
    });
    it("predicate anyOf negative", function () {
        return assert.ok(!Predicate_1.Predicate.anyOf(function (x) { return x < 10; }, function (x) { return x > 20; })(15));
    });
    it("predicate noneOf", function () {
        return assert.ok(!Predicate_1.Predicate.noneOf(function (x) { return x < 10; }, function (x) { return x > 20; })(4));
    });
    it("predicate noneOf negative", function () {
        return assert.ok(Predicate_1.Predicate.noneOf(function (x) { return x < 10; }, function (x) { return x > 20; })(15));
    });
});
//# sourceMappingURL=Predicate.js.map