"use strict";
exports.__esModule = true;
var Tuple2_1 = require("../src/Tuple2");
var Option_1 = require("../src/Option");
var assert = require("assert");
describe("Tuple2 manipulation", function () {
    it("fst works", function () { return assert.equal(1, Tuple2_1.Tuple2.of(1, 2).fst()); });
    it("snd works", function () { return assert.equal(2, Tuple2_1.Tuple2.of(1, 2).snd()); });
    it("equality works", function () { return assert.ok(Tuple2_1.Tuple2.of(1, 2).equals(Tuple2_1.Tuple2.of(1, 2))); });
    it("equality fails when it should", function () { return assert.ok(!Tuple2_1.Tuple2.of(1, 2).equals(Tuple2_1.Tuple2.of(2, 2))); });
    it("doesn't throw when given another type on equals", function () { return assert.equal(false, Tuple2_1.Tuple2.of(1, 2).equals([1, 2])); });
    it("doesn't throw when given null on equals", function () { return assert.equal(false, Tuple2_1.Tuple2.of(1, 2).equals(null)); });
    it("map1 works", function () { return assert.ok(Tuple2_1.Tuple2.of(2, 2).equals(Tuple2_1.Tuple2.of(1, 2).map1(function (x) { return x * 2; }))); });
    it("map2 works", function () { return assert.ok(Tuple2_1.Tuple2.of(1, 4).equals(Tuple2_1.Tuple2.of(1, 2).map2(function (x) { return x * 2; }))); });
    it("bimap works", function () { return assert.ok(Tuple2_1.Tuple2.of(2, 4).equals(Tuple2_1.Tuple2.of(1, 2).map(function (x, y) { return Tuple2_1.Tuple2.of(x * 2, y * 2); }))); });
    it("build from tuple works", function () { return assert.ok(Tuple2_1.Tuple2.of(1, 2).equals(Tuple2_1.Tuple2.ofPair([1, 2]))); });
    it("build from array works - success", function () { return assert.ok(Option_1.Option.of(Tuple2_1.Tuple2.of(1, 2)).equals(Tuple2_1.Tuple2.ofArray([1, 2]))); });
    it("build from array works - failure", function () { return assert.ok(Tuple2_1.Tuple2.ofArray([1, 2, 3]).isNone()); });
});
//# sourceMappingURL=Tuple2.js.map